package net.mail;
import com.cycling74.max.*;
import java.util.Properties;
import java.io.*;
import javax.mail.*;
import javax.mail.internet.*;

public class recv extends MaxObject {

    private static final String POP3_PROTOCOL = "pop3";

    private String username = null;
    private String password = null;
    private String folder = "inbox";
    private String protocol = POP3_PROTOCOL;
    private String mailserver = "localhost";

    private static final int NORMAL_OUTLET = 0;
    private static final int EXCEPTION_OUTLET = 1;

    public recv(Atom args[]) {
    		declareIO(1,2);
    		declareAttribute("username");
    		declareAttribute("password");
    		declareAttribute("folder");
    		declareAttribute("protocol");
    		declareAttribute("mailserver");
    }

     // Get a stream to the file to which we will write.
    private OutputStream getFileSaveStream(String name) throws IOException {
    		return new BufferedOutputStream(new FileOutputStream(name));
    }

    //save a message number to a text file.  
    //messages are numbered starting at 1.
    public void saveMessage(int msgNum, String filename) {
		Properties props = new Properties();
		props.put("mail.host", mailserver);
		try {
		    Session session = Session.getInstance(props, null);
		    Store store = session.getStore(protocol);
		    store.connect(mailserver, username, password);
		    Folder fold = store.getFolder(folder);
		    fold.open(Folder.READ_ONLY);
		    MimeMessage msg = (MimeMessage)fold.getMessage(msgNum);
	
		    OutputStream out = getFileSaveStream(filename);
		    msg.writeTo(out);
	
		    outlet(NORMAL_OUTLET, 1);
	
		    store.close();
		    out.close();
		} catch (IOException ie) {
		    showException(null, ie);
		    outlet(EXCEPTION_OUTLET, ie.toString());
		} catch (MessagingException me) {
		    showException(null, me);
		    outlet(EXCEPTION_OUTLET, me.toString());
		}
    }


    //save an attachment.  
    //msgNum is numbered starting at 1,
    //attachmentNum is numbered starting at 0.
    public void saveAttachment(int msgNum, int attachmentNum, String filename) {
		Properties props = new Properties();
		props.put("mail.host", mailserver);
		try {
		    Session session = Session.getInstance(props, null);
		    Store store = session.getStore(protocol);
		    store.connect(mailserver, username, password);
		    Folder fold = store.getFolder(folder);
		    fold.open(Folder.READ_ONLY);
		    MimeMessage msg = (MimeMessage)fold.getMessage(msgNum);
		    String messageType = msg.getContentType();
		    if (msg.isMimeType("multipart/mixed")) {
				MimeMultipart mp = (MimeMultipart)msg.getContent();
				BodyPart att = mp.getBodyPart(attachmentNum);
				OutputStream out = getFileSaveStream(filename);
				att.writeTo(out);
				out.close();
				outlet(0, 1);
		    } else {
		    	outlet(0, 0);
		    }	
		    store.close();
		} catch (IOException ie) {
		    showException(null, ie);
		    outlet(EXCEPTION_OUTLET, ie.toString());
		} catch (MessagingException me) {
		    showException(null, me);
		    outlet(EXCEPTION_OUTLET, me.toString());
		}
    }
}
